SystemOrganization addCategory: #'OB-Mondrian-Diagrams'!

!OBEnhancementDefinitionPanel methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/31/2008 10:51'!
codeTabPanel
    codeTabPanel ifNil: [codeTabPanel := (OBCodeTabPanel new browser: browser; definitionPanel: self; yourself)].
    ^codeTabPanel! !

!OBClassAwareNode methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 13:44'!
realClasses
    ^Array with: self theClass! !

!OBMorphBuilder methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 4/11/2008 11:15'!
codeTabPanel: aCodeTabPanel with: aBlock
	| tabPanel |
	tabPanel := OBRadioButtonBar
					on: aCodeTabPanel
					list: #list
					selected: #selection
					changeSelected: #selection:.
	tabPanel height: 23;
		      hResizing: #shrinkWrap;
		      vResizing: #shrinkWrap;
		      cellInset: aCodeTabPanel cellInset;	
	           cellPositioning: #topLeft.	
	tabPanel adoptPaneColor: aCodeTabPanel browser defaultBackgroundColor darker darker darker.	
		
	current ifNotNil: [current addMorphBack: tabPanel].
	^ self current: tabPanel do: aBlock! !

!CompiledMethod methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/21/2008 10:20'!
compiledMethod
    ^self! !

OBPanel subclass: #OBCodeTabPanel
	instanceVariableNames: 'definitionPanel selection commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:37'!
buildOn: aBuilder
     ^aBuilder codeTabPanel: self with: []! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/12/2007 14:27'!
cellInset
    ^5! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/22/2007 17:00'!
color
	^browser defaultBackgroundColor ! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/3/2007 15:04'!
commands
	| tmpCommands |
	self node ifNil: [^ #()].
	tmpCommands _ (self announce: OBNodeCommandScan) commandsOn: self node for: self. 
	commands := (tmpCommands select: [:ea | ea wantsTabButton]) asSortedCollection: [:a :b | (a priority < b priority) or: [a priority = b priority and: [a label <= b label]]].
	^commands! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:05'!
defaultLabelSelector
    ^#shortLabel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:58'!
definitionPanel
    ^definitionPanel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:45'!
definitionPanel: aDefinitionPanel
    definitionPanel := aDefinitionPanel! !

!OBCodeTabPanel methodsFor: 'executing' stamp: 'dr 10/8/2008 14:07'!
executeCommand
     | cmd |
     cmd := commands at: self selection.
     cmd isActive ifTrue: [cmd execute].! !

!OBCodeTabPanel methodsFor: 'initializing' stamp: 'dr 6/29/2007 16:26'!
initialize
    super initialize.
    selection := 1.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 7/19/2007 16:06'!
isEnabled: aButtonModel
    ^(self commands detect: [:ea | (ea perform: self defaultLabelSelector) = aButtonModel label] 
                        ifNone: [^false]) isActive.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 10/19/2007 14:32'!
isSourceTabSelected
   ^self selection = 1! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 6/28/2007 10:37'!
isTab
    ^true! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 16:05'!
list 
    ^self commands collect: [:ea | ea perform: self defaultLabelSelector]! !

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 14:32'!
maxWidth
    ^self commands inject: 0 into: [:width :cmd | width := width + (cmd label size * 7 + self cellInset). width]! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:01'!
node
    ^self definitionPanel currentOrRootNode! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/22/2007 17:19'!
panel
    ^self! !

!OBCodeTabPanel methodsFor: 'executing' stamp: 'dr 10/19/2007 13:55'!
selectFirst
    commands ifNotNil: [self selection: 1]! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 16:07'!
selection
	^selection! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/12/2007 14:56'!
selection: anInteger
	selection := anInteger.
     self executeCommand.
	self changed: #selection.! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 14:54'!
selectionChanged: ann
	self changed: #list! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/29/2007 14:21'!
subscribe
	self announcer
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self! !

!OBClosableDefinitionPanel methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/31/2008 10:51'!
codeTabPanel
    codeTabPanel ifNil: [codeTabPanel := (OBCodeTabPanel new browser: browser; definitionPanel: self; yourself)].
    ^codeTabPanel! !

OBCommand subclass: #OBCmdMondrianTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

OBCmdMondrianTab subclass: #OBCmdClassBlueprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdClassBlueprint methodsFor: 'configuration' stamp: 'dr 1/29/2008 17:03'!
diagramSelector
    ^#classBlueprint! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/3/2007 14:57'!
label
    ^'Class Blueprint'! !

!OBCmdClassBlueprint methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:00'!
priority
    ^2! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 10/8/2008 14:57'!
shortLabel
    ^'Cl. Bluep.'! !

!OBCmdClassBlueprint methodsFor: 'testing' stamp: 'dr 10/20/2008 08:52'!
wantsTabButton
    ^true! !

OBCmdClassBlueprint subclass: #OBCmdDynamicClassBlueprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdDynamicClassBlueprint methodsFor: 'configuration' stamp: 'dr 1/29/2008 17:03'!
diagramSelector
    ^#dynamicClassBlueprint! !

!OBCmdDynamicClassBlueprint methodsFor: 'testing' stamp: 'dr 10/21/2008 11:39'!
isActive 
    ^(super isActive and: [Smalltalk hasClassNamed: #HODataBase]) and: [requestor browser class dynamicBrowser].! !

!OBCmdDynamicClassBlueprint methodsFor: 'command' stamp: 'dr 10/22/2007 11:04'!
label
    ^'Class Blueprint dynamic'! !

!OBCmdDynamicClassBlueprint methodsFor: 'command' stamp: 'dr 10/8/2008 14:57'!
shortLabel
    ^'Dyn. Cl. Bluep.'! !

!OBCmdDynamicClassBlueprint methodsFor: 'testing' stamp: 'dr 10/11/2008 16:12'!
wantsTabButton 
    ^false! !

OBCmdMondrianTab subclass: #OBCmdClassCollaboration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdClassCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:45'!
diagramSelector
    ^#classCollaboration! !

!OBCmdClassCollaboration methodsFor: 'testing' stamp: 'dr 10/21/2008 11:40'!
isActive
     (Smalltalk hasClassNamed: #HODataBase) ifFalse: [^false].
    ^(target respondsTo: #theClass) and: [target theClass notNil]
         and: [(Smalltalk at: #HODataBase) default isInstrumentedClass: target theClass]! !

!OBCmdClassCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:45'!
label
    ^'Class Collaboration'! !

!OBCmdClassCollaboration methodsFor: 'sorting' stamp: 'dr 10/8/2008 14:53'!
priority
    ^4! !

!OBCmdClassCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:56'!
shortLabel
    ^'Class Coll.'! !

!OBCmdClassCollaboration methodsFor: 'testing' stamp: 'dr 10/21/2008 10:18'!
wantsTabButton
    ^false! !

OBCmdMondrianTab subclass: #OBCmdMethodCollaboration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdMethodCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:44'!
diagramSelector
    ^#methodCollaboration! !

!OBCmdMethodCollaboration methodsFor: 'testing' stamp: 'dr 10/21/2008 11:41'!
isActive
    (Smalltalk hasClassNamed: #HODataBase) ifFalse: [^false].
    ^target isMethodNode and: [(Smalltalk at: #HODataBase) default isInstrumentedMethod: target reference]! !

!OBCmdMethodCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:43'!
label
    ^'Method Collaboration'! !

!OBCmdMethodCollaboration methodsFor: 'sorting' stamp: 'dr 10/8/2008 14:53'!
priority
    ^5! !

!OBCmdMethodCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:55'!
shortLabel
    ^'Method Coll.'! !

!OBCmdMethodCollaboration methodsFor: 'testing' stamp: 'dr 10/21/2008 10:18'!
wantsTabButton
    ^false! !

!OBCmdMondrianTab methodsFor: 'configuration' stamp: 'dr 1/29/2008 10:54'!
diagramSelector
    self subclassResponsibility! !

!OBCmdMondrianTab methodsFor: 'command' stamp: 'dr 1/29/2008 10:55'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: (mondrianPanel perform: self diagramSelector).! !

!OBCmdMondrianTab methodsFor: 'command' stamp: 'dr 1/29/2008 10:53'!
group
	^ #identity! !

!OBCmdMondrianTab methodsFor: 'testing' stamp: 'dr 10/8/2008 14:09'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [(target respondsTo: #theClass) and: [target theClass notNil]]! !

!OBCmdMondrianTab methodsFor: 'testing' stamp: 'dr 1/29/2008 10:53'!
wantsTabButton
    ^true! !

OBCmdMondrianTab subclass: #OBCmdPackageCollaboration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdPackageCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:47'!
diagramSelector
    ^#packageCollaboration! !

!OBCmdPackageCollaboration methodsFor: 'testing' stamp: 'dr 10/30/2008 09:49'!
isActive
     (Smalltalk hasClassNamed: #HODataBase) ifFalse: [^false].
    ^((target isPackage or: [target isClassCategoryNode]) 
        and: [(Smalltalk at: #HODataBase) default isInstrumentedPackage: target workingCopy])
        or: [(target respondsTo: #theClass) and: [target theClass notNil] 
	   and: [(Smalltalk at: #HODataBase) default isInstrumentedClass: target theClass]]! !

!OBCmdPackageCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:47'!
label
    ^'Package Collaboration'! !

!OBCmdPackageCollaboration methodsFor: 'sorting' stamp: 'dr 10/8/2008 14:53'!
priority
    ^3! !

!OBCmdPackageCollaboration methodsFor: 'command' stamp: 'dr 10/8/2008 14:56'!
shortLabel
    ^'Package Coll.'! !

!OBCmdPackageCollaboration methodsFor: 'testing' stamp: 'dr 10/21/2008 10:17'!
wantsTabButton
    ^false! !

OBCmdMondrianTab subclass: #OBCmdReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdReferences methodsFor: 'command' stamp: 'dr 1/29/2008 17:12'!
diagramSelector
    ^#references! !

!OBCmdReferences methodsFor: 'command' stamp: 'dr 1/29/2008 10:39'!
label
    ^'References'! !

!OBCmdReferences methodsFor: 'sorting' stamp: 'dr 1/29/2008 17:11'!
priority
    ^3! !

!OBCmdReferences methodsFor: 'command' stamp: 'dr 1/29/2008 10:40'!
shortLabel
    ^'Refs'! !

!OBCmdReferences methodsFor: 'testing' stamp: 'dr 10/8/2008 14:57'!
wantsTabButton
    ^false
    "^(Smalltalk includesKey: #HODataBase) and: [requestor browser class dynamicBrowser]."! !

OBCmdMondrianTab subclass: #OBCmdSourceCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 10/19/2007 14:28'!
execute
	requestor definitionPanel changeToSourceCodePanel! !

!OBCmdSourceCode methodsFor: 'testing' stamp: 'dr 7/19/2007 15:04'!
isActive
	^requestor isKindOf: OBCodeTabPanel! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/28/2007 10:27'!
label
    ^'Source Code'! !

!OBCmdSourceCode methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:01'!
priority
    ^1! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 7/12/2007 14:36'!
shortLabel
    ^'Src C.'! !

OBCmdMondrianTab subclass: #OBCmdSystemComplexity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 1/29/2008 10:56'!
diagramSelector
    ^#systemComplexity! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 10/8/2008 13:43'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) "and: [target respondsTo: #theClass]"! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 6/15/2007 16:49'!
label
    ^'System Complexity'! !

!OBCmdSystemComplexity methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 10/8/2008 14:56'!
shortLabel
    ^'Sys. Complex.'! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 10/20/2008 08:51'!
wantsTabButton
    ^true! !

OBCmdMondrianTab subclass: #OBCmdUmlDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdUmlDiagram methodsFor: 'configuration' stamp: 'dr 1/29/2008 10:55'!
diagramSelector
    ^#umlDiagram! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 10/8/2008 14:27'!
isActive
	^requestor isKindOf: OBCodeTabPanel! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 6/19/2007 15:58'!
label
    ^'UML Diagram'! !

!OBCmdUmlDiagram methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 7/12/2007 14:34'!
shortLabel
    ^'UML Diag.'! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 10/20/2008 08:52'!
wantsTabButton
    ^true! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdClassBlueprint
	^OBCmdClassBlueprint! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 14:51'!
cmdClassCollaboration
	^OBCmdClassCollaboration! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/22/2007 11:05'!
cmdDynamicClassBlueprint
	^OBCmdDynamicClassBlueprint! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 14:51'!
cmdMethodCollaboration
	^OBCmdMethodCollaboration! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 14:51'!
cmdPackageCollaboration
	^OBCmdPackageCollaboration! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 14:54'!
cmdReferences
   ^OBCmdReferences! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdSourceCode
	^ OBCmdSourceCode! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdSystemComplexity
	^ OBCmdSystemComplexity! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/8/2008 14:54'!
cmdUmlDiagram
	^OBCmdUmlDiagram! !

OBDefinitionPanel subclass: #OBMondrianPanel
	instanceVariableNames: 'visualization contentMorph node sequenceDiagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 14:58'!
classBlueprint
    self setVisualization: #classBlueprint.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/8/2008 14:58'!
classCollaboration
    self setVisualization: #classCollaboration.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/22/2007 11:46'!
createClassBlueprint
	| view theClass |
	theClass := self currentNode theClass.
	view := MOClassBlueprint ofClass: theClass inPanel: self. 
	view := view viewBlueprint.
	^self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/11/2008 18:18'!
createClassCollaboration
    ^self createContentMorphWithView: self sequenceDiagram viewClassCollaboration! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 14:41'!
createContentMorph
    ^self perform: ('create', visualization asString capitalized) asSymbol
! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 15:00'!
createContentMorphWithView: aView
    contentMorph := ScrollPane new
          borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

    contentMorph scroller addMorph: (MOViewer on: aView graph).
    ^contentMorph
! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/22/2007 11:46'!
createDynamicClassBlueprint
	| view theClass |
	theClass := self currentNode theClass.
	view := MOClassBlueprint ofClass: theClass inPanel: self. 
	view := view viewDynamicBlueprint.
	^self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/10/2008 11:56'!
createMethodCollaboration
    "^self createContentMorphWithView: (MOPainting createSystemComplexityOf: self currentNode theClass)"
   ^self createContentMorphWithView: self sequenceDiagram viewMethodCollaboration! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/10/2008 11:56'!
createPackageCollaboration
	^self createContentMorphWithView: self sequenceDiagram viewPackageCollaboration! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 5/5/2008 17:22'!
createReferences
	| view theClass numRefsToClass sumRefs maxWidth | 
	theClass _ self currentNode theClass. 

	view _ MORenderer new.
	view layout: ((MORadialTreeLayout new)
				gap: 10;
				roots: [:each | Array with: (view elementOf: theClass)];
				children: [:each | (each referencedClasses copyWithout: theClass) collect: [:ea | view elementOf: ea]]).
	view style: 
		(MORectangleShape new 
		     borderColor: [:ea | ea = theClass ifTrue: [Color red] ifFalse: [Color black]]) , 
		(MOMaxExtent new 
			width: 5; 
			height: 5),
			(MOStringShape new string: [:ea | ea name asString]).	
	view add: theClass.		
	view addAll: (theClass referencedClasses copyWithout: theClass).
	view layout: ((MOConnectorLayout new)
				source: [:each | view graph elementOf: each model key];
				sourcePosition: #topCenter;
				target: [:each | view graph elementOf: each model value];
				targetPosition: #bottomCenter).
	
	numRefsToClass _ Dictionary new.
	theClass referencedClasses do: [:class | numRefsToClass at: class put: (theClass modelClass numberOfReferencesToClass: class)].
	sumRefs _ numRefsToClass values inject: 0 into: [:sum :num | sum + num].
	maxWidth _ 20.			
				
	view style: (MOStraightLineShape new 
	                 width: [:assoc | ((numRefsToClass at: assoc key)*10/sumRefs) asFloat rounded max: 1]).
	view 
		addAll: (theClass referencedClasses collect: [:each | each -> theClass]).
	^ self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/8/2008 13:44'!
createSystemComplexity
    ^self createContentMorphWithView: (MOPainting createSystemComplexityOf: self currentNode realClasses)! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/8/2008 14:26'!
createUmlDiagram
	| view roots classes | 
	classes _ self currentNode realClasses.
	roots _ Set new.
	classes do: [:class | (class allSuperclasses noneSatisfy: [:ea | classes includes: ea])
		                         ifTrue: [roots add: class]].
	roots _ roots asOrderedCollection.
		
	
	view _ MORenderer new.
	view layout: ((MOVerticalSpacedTreeLayout new)
				gap: [:ea | 10 @ 40];
				roots: [:each | roots collect: [:class | view graph elementOf: class]];
				children: [:each | each subclasses collect: [:ea | view elementOf: ea]]).
	view style: MOUmlClass new.
	roots do: [:class | view addAll: class withAllSubclasses].
	view layout: ((MOConnectorLayout new)
				source: [:each | view graph elementOf: each model key];
				sourcePosition: #topCenter;
				target: [:each | view graph elementOf: each model value];
				targetPosition: #bottomCenter).
	view style: MOUmlInheritance new.
	roots do: [:class | view addAll: (class allSubclasses collect: [ :each | each -> each superclass])].
	^ self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:24'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/22/2007 11:42'!
dynamicClassBlueprint
    self setVisualization: #dynamicClassBlueprint.
    ^self morph! !

!OBMondrianPanel methodsFor: 'initializing' stamp: 'dr 6/22/2007 15:00'!
initialize
    super initialize.
    visualization := #systemComplexity! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/8/2008 14:58'!
methodCollaboration
    self setVisualization: #methodCollaboration.
    ^self morph! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/29/2007 14:40'!
morph
    ^self createContentMorph! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node
	^node! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node: aNode
	node := aNode! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 10/8/2008 14:58'!
packageCollaboration
    self setVisualization: #packageCollaboration.
    ^self morph! !

!OBMondrianPanel methodsFor: 'redrawing' stamp: 'dr 10/10/2008 12:17'!
redraw: aSymbol
    contentMorph scroller removeMorph: contentMorph scroller submorphs first.
    contentMorph scroller addMorph: (MOViewer on: (self sequenceDiagram perform: aSymbol) graph)! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 1/29/2008 11:04'!
references
    self setVisualization: #references.
    ^self morph! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 10/10/2008 12:05'!
sequenceDiagram
    sequenceDiagram ifNil: [sequenceDiagram _ MOSequenceDiagram new setPanel: self].
    ^sequenceDiagram! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/22/2007 14:38'!
setVisualization: aSymbol
    visualization := aSymbol! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
systemComplexity
    self setVisualization: #systemComplexity.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
umlDiagram
	self setVisualization: #umlDiagram.
	^self morph! !
